---
title: IDBRequest.transaction
slug: Web/API/IDBRequest/transaction
tags:
  - API
  - Database
  - IDBRequest
  - IndexedDB
  - Property
  - Reference
  - Storage
  - transaction
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>transaction</code></strong> read-only property of the IDBRequest interface returns the transaction for the request, that is, the transaction the request is being made inside.</p>

<p>This property can be <code>null</code> for requests not made within transactions, such as for requests returned from {{domxref("IDBFactory.open")}} — in this case you're just connecting to a database, so there is no transaction to return. If a version upgrade is needed when opening a database then during the {{domxref("IDBOpenDBRequest.onupgradeneeded", "upgradeneeded")}} event handler the <strong><code>transaction</code></strong> property will be an {{domxref("IDBTransaction")}} with {{domxref("IDBTransaction.mode", "mode")}} equal to <code>"versionchange"</code>, and can be used to access existing object stores and indexes, or abort the upgrade. Following the upgrade, the <strong><code>transaction</code></strong> property will again be <code>null</code>.</p>

<p>{{AvailableInWorkers}}</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>myTransaction</em> = <em>request</em>.transaction;</pre>

<h3 id="Value">Value</h3>

<p>An {{domxref("IDBTransaction")}}.</p>

<h2 id="Example">Example</h2>

<p>The following example requests a given record title, <code>onsuccess</code> gets the associated record from the {{domxref("IDBObjectStore")}} (made available as <code>objectStoreTitleRequest.result</code><span style="line-height: 1.5;">), updates one property of the record, and then puts the updated record back into the object store in another request. The source of the requests is logged to the developer console — both originate from the same transaction. For a full working example, see our </span><a href="https://github.com/mdn/to-do-notifications/" style="line-height: 1.5;">To-do Notifications</a><span style="line-height: 1.5;"> app (</span><a href="https://mdn.github.io/to-do-notifications/" style="line-height: 1.5;">view example live</a><span style="line-height: 1.5;">.)</span></p>

<pre class="brush: js">var title = "Walk dog";

// Open up a transaction as usual
var objectStore = db.transaction(['toDoList'], "readwrite").objectStore('toDoList');

// Get the to-do list object that has this title as it's title
var objectStoreTitleRequest = objectStore.get(title);

objectStoreTitleRequest.onsuccess = function() {
  // Grab the data object returned as the result
  var data = objectStoreTitleRequest.result;

  // Update the notified value in the object to "yes"
  data.notified = "yes";

  // Create another request that inserts the item back
  // into the database
  var updateTitleRequest = objectStore.put(data);

  <span style="font-size: 1rem;">// Log the transaction that originated this request</span>
  console.log("The transaction that originated this request is " + updateTitleRequest.transaction);

  // When this new request succeeds, run the displayData()
  // function again to update the display
  updateTitleRequest.onsuccess = function() {
    displayData();
  };
};

</pre>

<p>This example shows how a the <strong><code>transaction</code></strong> property can be used during a version upgrade to access existing object stores:</p>

<pre class="brush: js">var openRequest = indexedDB.open('db', 2);
console.log(openRequest.transaction); // Will log "null".

openRequest.onupgradeneeded = function(event) {
  console.log(openRequest.transaction.mode); // Will log "versionchange".
  var db = openRequest.result;
  if (event.oldVersion &lt; 1) {
    // New database, create "books" object store.
    db.createObjectStore('books');
  }
  if (event.oldVersion &lt; 2) {
    // Upgrading from v1 database: add index on "title" to "books" store.
    var bookStore = openRequest.transaction.objectStore('books');
    bookStore.createIndex('by_title', 'title');
  }
};

openRequest.onsuccess = function() {
  console.log(openRequest.transaction); // Will log "null".
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbrequest-transaction', 'transaction')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbrequest-transaction", "transaction")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBRequest.transaction")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
